//////////////////////////////////////////////////////////////////////////////
//
//  File:       _mdlv8.cpp
//  Source:     _mdlv8.cpp
//
//  Copyright:  1996-2001, Microsoft Corporation
//  Modified :  2003, Sumbera
//

///////////////////////////////////////////////////////////////// Trampolines.





int  apiCount=0;


#pragma warning(disable:4100)   // Trampolines don't use formal parameters.



DETOUR_TRAMPOLINE(DWORD __stdcall Real_GetModuleFileNameW(HMODULE a0,
                                                          LPWSTR a1,
                                                          DWORD a2),
                  GetModuleFileNameW);
DETOUR_TRAMPOLINE(LPSTR __stdcall Real_GetEnvironmentStrings(void),
                  GetEnvironmentStrings);
DETOUR_TRAMPOLINE(DWORD __stdcall Real_GetCurrentProcessId(void),
                  GetCurrentProcessId);
DETOUR_TRAMPOLINE(BOOL __stdcall Real_CloseHandle(HANDLE a0),
                  CloseHandle);

DETOUR_TRAMPOLINE(BOOL __stdcall Real_WriteFile(HANDLE a0,
                                                LPCVOID a1,
                                                DWORD a2,
                                                LPDWORD a3,
                                                LPOVERLAPPED a4),
                  WriteFile);
DETOUR_TRAMPOLINE(void __stdcall Real_GetSystemTimeAsFileTime(LPFILETIME a0),
                  GetSystemTimeAsFileTime);
DETOUR_TRAMPOLINE(BOOL __stdcall Real_SetNamedPipeHandleState(HANDLE a0,
                                                              LPDWORD a1,
                                                              LPDWORD a2,
                                                              LPDWORD a3),
                  SetNamedPipeHandleState);

DETOUR_TRAMPOLINE(HANDLE __stdcall Real_CreateFileW(LPCWSTR a0,
                                                    DWORD a1,
                                                    DWORD a2,
                                                    LPSECURITY_ATTRIBUTES a3,
                                                    DWORD a4,
                                                    DWORD a5,
                                                    HANDLE a6),
                  CreateFileW);
DETOUR_TRAMPOLINE(BOOL __stdcall Real_FlushFileBuffers(HANDLE a0),
                  FlushFileBuffers);
DETOUR_TRAMPOLINE(BOOL __stdcall Real_WaitNamedPipeW(LPCWSTR a0,
                                                     DWORD a1),
                  WaitNamedPipeW);

///////////////////////////////////////////////////////////////////// MDL
/*DETOUR_TRAMPOLINE(VOID*  Real_mdlDialog_open(VOID  *a0,
                                             int   a1),
                                       mdlDialog_open);

///////////////////////////////////////////////////////////////////// Detours.
//
VOID*  Mine_mdlDialog_open(VOID *a0,int a1)
{
    _PrintEnter("mdlDialog_open(%l)\n", a0);

    VOID *rv = NULL;
    __try {
        rv = Real_mdlDialog_open(a0,a1);
    } __finally {
        _PrintExit("mdlDialog_open() <- %lx\n", rv);
    };
    return rv;
}
*/


API_TRACE_DEC(mdlDialog_open);
API_TRACE_DEC(mdlDialog_openAdvisoryBox);
API_TRACE_DEC(mdlDialog_openAlert);
API_TRACE_DEC(mdlDialog_openAlertById);
API_TRACE_DEC(mdlDialog_openCompletionBar);
API_TRACE_DEC(mdlDialog_openInfoBox);
API_TRACE_DEC(mdlDialog_openInfoBoxOptional);
API_TRACE_DEC(mdlDialog_openMessageBox);
API_TRACE_DEC(mdlDialog_openModal);
API_TRACE_DEC(mdlDialog_openModalWithMD);
API_TRACE_DEC(mdlDialog_openModalWithMDAndBsiDataP);
API_TRACE_DEC(mdlDialog_openOKCancelBoxOptional);
API_TRACE_DEC(mdlDialog_openPalette);
API_TRACE_DEC(mdlDialog_openWithDBQuery);
API_TRACE_DEC(mdlDialog_openWithMD);


VOID TrampolineWith(VOID)
{
 /*    DetourFunctionWithTrampoline((PBYTE)Real_mdlDialog_open,
                                 (PBYTE)Mine_mdlDialog_open);*/
    API_TRACE_DO(mdlDialog_open);
    API_TRACE_DO(mdlDialog_openAdvisoryBox);
    API_TRACE_DO(mdlDialog_openAlert);
    API_TRACE_DO(mdlDialog_openAlertById);
    API_TRACE_DO(mdlDialog_openCompletionBar);
    API_TRACE_DO(mdlDialog_openInfoBox);
    API_TRACE_DO(mdlDialog_openInfoBoxOptional);
    API_TRACE_DO(mdlDialog_openMessageBox);
    API_TRACE_DO(mdlDialog_openModal);
    API_TRACE_DO(mdlDialog_openModalWithMD);
    API_TRACE_DO(mdlDialog_openModalWithMDAndBsiDataP);
    API_TRACE_DO(mdlDialog_openOKCancelBoxOptional);
    API_TRACE_DO(mdlDialog_openPalette);
    API_TRACE_DO(mdlDialog_openWithDBQuery);
    API_TRACE_DO(mdlDialog_openWithMD);

}